/* 
 * DefenseAI.java 1.0 2002-09-03
 *
 *  2002 Jouni Smed
 *
 * This software is provided for educational and non-commercial use only.
 *
 */
import fi.utu.cs.hockey.ai.*;

public class DefenseAI extends AI implements Constants
	{
	public void react()
		{
		if (!isGameStopped())
			{
			if (isPuckWithinReach())
				{
				switch (getPosition())
					{
					case LEFT_DEFENSE:
						head(headingTo(player(true, LEFT_WING)));
						break;
					case RIGHT_DEFENSE:
						head(headingTo(player(true, RIGHT_WING)));
						break;
					}
				brake(1.0);
				shoot(0.7);
				}
			else
				{
				double[] puck = puck();
				switch (getPosition())
					{
					case LEFT_DEFENSE:
						if (player(false, RIGHT_WING)[Y_COORDINATE] < OUR_ENDZONE_FACEOFF)
							head(headingTo(player(false, RIGHT_WING)));
						else
							{
							if (puck[X_COORDINATE] < 0.0)
								head(headingTo(puck));
							else
								head(headingTo(FACEOFF_LEFT, puck[Y_COORDINATE] - 5.0));
							}
						break;
					case RIGHT_DEFENSE:
						if (player(false, LEFT_WING)[Y_COORDINATE] < OUR_ENDZONE_FACEOFF)
							head(headingTo(player(false, LEFT_WING)));
						else
							{
							if (puck[X_COORDINATE] > 0.0)
								head(headingTo(puck));
							else
								head(headingTo(FACEOFF_RIGHT, puck[Y_COORDINATE] - 5.0));
							}
						break;
					}
				if (player(true, getPosition())[Y_COORDINATE] < OUR_BLUE_LINE)
					{
					dash(0.5);
					}
				else
					{
					dash(1.0);
					}
				}			
			}
		}		
	}