/* 
 * ForwardAI.java 1.0 2002-09-03
 *
 *  2002 Jouni Smed
 *
 * This software is provided for educational and non-commercial use only.
 *
 */
import fi.utu.cs.hockey.ai.*;

public class ForwardAI extends AI implements Constants
	{
	public void react()
		{
		if (!isGameStopped())
			{
			double[] puck = puck();
			double[] me = player(true, getPosition());
			if (isOffside(true) & me[Y_COORDINATE] > THEIR_BLUE_LINE)
				{
				head(Math.PI);
				dash(1.0);
				}
			else
				{
				if (isPuckWithinReach())
					{
					switch (getPosition())
						{
						case CENTER:
							if (!isOffside(true) & me[Y_COORDINATE] > CENTER_LINE)
								{
								head(headingTo(0.0, THEIR_GOAL_LINE));
								shoot(1.0);
								}
							else
								{
								head(headingTo(player(true, LEFT_DEFENSE)));
								shoot(0.5);
								}
							break;
						default:
							if (me[Y_COORDINATE] > THEIR_BLUE_LINE)
								{
								head(headingTo(0.0, THEIR_GOAL_LINE));
								shoot(0.7);
								}
							else
								{
								head(headingTo(player(true, CENTER)));
								shoot(0.6);
								}
							break;
						}
					dash(0.2);
					}
				else
					{
					switch (getPosition())
						{
						case CENTER:
							if (puck[X_COORDINATE] >= FACEOFF_LEFT + 2.0 & 
									puck[X_COORDINATE] <= FACEOFF_RIGHT - 2.0)
								head(headingTo(puck));
							else
								head(headingTo(0.0, puck[Y_COORDINATE] - 1.0));
							break;
						case LEFT_WING:
							if (puck[X_COORDINATE] < FACEOFF_LEFT + 2.0)
								head(headingTo(puck));
							else
								head(headingTo(FACEOFF_LEFT, puck[Y_COORDINATE] - 1.5));
							break;
						case RIGHT_WING:
							if (puck[X_COORDINATE] > FACEOFF_RIGHT - 2.0)
								head(headingTo(puck));
							else
								head(headingTo(FACEOFF_RIGHT, puck[Y_COORDINATE] - 1.5));
							break;
						}
					dash(1.0);
					}
				}
			}
		}		
	}